#include "Buffer.hpp"

Buffer::Buffer(GLenum shape): Shape(shape) {
    glGenBuffers(1, &VertexBufferID);
}

Buffer::~Buffer() {
    glDeleteBuffers(1, &VertexBufferID);
}

void Buffer::enableVertexAttrib() {
    glEnableVertexAttribArray(0);
    glBindBuffer(GL_ARRAY_BUFFER, VertexBufferID);
    glVertexAttribPointer(
        0,        // attribute
        3,        // size
        GL_FLOAT, // type
        GL_FALSE, // normalized?
        0,        // stride
        (void *)0 // array buffer offset
    );
}
void Buffer::enableAllAttribs() {
    enableVertexAttrib();
}
void Buffer::disableVertexAttrib() {
    glDisableVertexAttribArray(0);
}
void Buffer::disableAllAttribs() {
    disableVertexAttrib();
}

void Buffer::setVertices(const unsigned long size, const void *data) {
    glBindBuffer(GL_ARRAY_BUFFER, VertexBufferID);
    glBufferData(GL_ARRAY_BUFFER, size, data, GL_STATIC_DRAW);
}